> For the complete documentation index, see [llms.txt](https://renewables.docs.helinplatform.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://renewables.docs.helinplatform.com/api-reference/models.md).

# Models

## The AuthTokenBaseSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"AuthTokenBaseSchema":{"properties":{"name":{"title":"Name","type":"string"},"sites":{"items":{"format":"uuid4","type":"string"},"title":"Sites","type":"array"}},"required":["name","sites"],"title":"AuthTokenBaseSchema","type":"object"}}}}
```

## The AuthTokenDetailsSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"AuthTokenDetailsSchema":{"properties":{"id":{"title":"Id","type":"string"},"name":{"title":"Name","type":"string"},"sites":{"items":{"format":"uuid4","type":"string"},"title":"Sites","type":"array"},"token":{"title":"Token","type":"string"}},"required":["name","sites","id","token"],"title":"AuthTokenDetailsSchema","type":"object"}}}}
```

## The AuthTokenUpdateRequestSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"AuthTokenUpdateRequestSchema":{"properties":{"name":{"title":"Name","type":"string"},"sites":{"items":{"format":"uuid4","type":"string"},"title":"Sites","type":"array"}},"required":["name","sites"],"title":"AuthTokenUpdateRequestSchema","type":"object"}}}}
```

## The AzureFriendlyHealthData object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"AzureFriendlyHealthData":{"properties":{"healthy":{"title":"Healthy","type":"boolean"},"node_name":{"title":"Node Name","type":"string"},"site_tag":{"title":"Site Tag","type":"string"},"tenant_tag":{"default":"backend_test","title":"Tenant Tag","type":"string"}},"required":["site_tag","node_name","healthy"],"title":"AzureFriendlyHealthData","type":"object"}}}}
```

## The CurtailCategoryRequest object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"CurtailCategoryRequest":{"properties":{"category":{"title":"Category","type":"string"},"device_tags":{"items":{"type":"string"},"nullable":true,"title":"Device Tags","type":"array"},"value":{"title":"Value","type":"integer"}},"required":["value","category"],"title":"CurtailCategoryRequest","type":"object"}}}}
```

## The CurtailmentLogResultSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"CurtailmentLogResultSchema":{"properties":{"not_updated_devices":{"additionalProperties":{"$ref":"#/components/schemas/NotUpdatedDeviceLogSchema"},"title":"Not Updated Devices","type":"object"},"updated_devices":{"additionalProperties":{"$ref":"#/components/schemas/UpdatedDeviceLogSchema"},"title":"Updated Devices","type":"object"}},"required":["updated_devices","not_updated_devices"],"title":"CurtailmentLogResultSchema","type":"object"},"NotUpdatedDeviceLogSchema":{"properties":{"detail":{"title":"Detail","type":"string"},"reason":{"title":"Reason","type":"string"}},"required":["reason","detail"],"title":"NotUpdatedDeviceLogSchema","type":"object"},"UpdatedDeviceLogSchema":{"properties":{"value":{"title":"Value","type":"number"}},"required":["value"],"title":"UpdatedDeviceLogSchema","type":"object"}}}}
```

## The CurtailmentOperationStatus object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"CurtailmentOperationStatus":{"enum":["completed","exception"],"title":"CurtailmentOperationStatus","type":"string"}}}}
```

## The CurtailmentServiceResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"CurtailmentServiceResponse":{"properties":{"not_updated_devices":{"additionalProperties":{"$ref":"#/components/schemas/NotUpdatedDeviceCurtailmentResponse"},"title":"Not Updated Devices","type":"object"},"updated_devices":{"additionalProperties":{"$ref":"#/components/schemas/UpdatedDeviceCurtailmentResponse"},"title":"Updated Devices","type":"object"}},"required":["updated_devices","not_updated_devices"],"title":"CurtailmentServiceResponse","type":"object"},"NotUpdatedDeviceCurtailmentResponse":{"properties":{"detail":{"title":"Detail","type":"string"},"reason":{"title":"Reason","type":"string"}},"required":["reason","detail"],"title":"NotUpdatedDeviceCurtailmentResponse","type":"object"},"UpdatedDeviceCurtailmentResponse":{"properties":{"value":{"anyOf":[{"type":"integer"},{"type":"string"}],"title":"Value"}},"required":["value"],"title":"UpdatedDeviceCurtailmentResponse","type":"object"}}}}
```

## The DeviceErrorsSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"DeviceErrorsSchema":{"properties":{"error_count":{"default":0,"title":"Error Count","type":"integer"},"errors":{"default":[],"items":{"type":"string"},"title":"Errors","type":"array"},"last_seen":{"default":"","title":"Last Seen","type":"string"},"site_id":{"format":"uuid","nullable":true,"title":"Site Id","type":"string"},"site_tag":{"nullable":true,"title":"Site Tag","type":"string"}},"title":"DeviceErrorsSchema","type":"object"}}}}
```

## The DeviceResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"DeviceResponse":{"properties":{"byteorder":{"nullable":true,"title":"Byteorder","type":"string"},"category":{"title":"Category","type":"string"},"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"data_format":{"nullable":true,"title":"Data Format","type":"string"},"default_value":{"title":"Default Value","type":"integer"},"delay_by":{"nullable":true,"title":"Delay By","type":"number"},"delay_on":{"nullable":true,"title":"Delay On","type":"number"},"device_tag":{"title":"Device Tag","type":"string"},"device_type_id":{"format":"uuid","title":"Device Type Id","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"},"include_in_curtailment":{"title":"Include In Curtailment","type":"boolean"},"max_value":{"title":"Max Value","type":"integer"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"min_value":{"title":"Min Value","type":"integer"},"modbus_id":{"nullable":true,"title":"Modbus Id","type":"integer"},"modbus_server_host":{"nullable":true,"title":"Modbus Server Host","type":"string"},"modbus_server_port":{"nullable":true,"title":"Modbus Server Port","type":"integer"},"node_id":{"format":"uuid","title":"Node Id","type":"string"},"peak_power_kw":{"nullable":true,"title":"Peak Power Kw","type":"integer"},"scaling":{"nullable":true,"title":"Scaling","type":"integer"},"start_register":{"nullable":true,"title":"Start Register","type":"integer"},"value":{"nullable":true,"title":"Value","type":"integer"},"wordorder":{"nullable":true,"title":"Wordorder","type":"string"}},"required":["device_tag","node_id","device_type_id","max_value","min_value","meta_data","include_in_curtailment","default_value","value","id","created_at","category"],"title":"DeviceResponse","type":"object"}}}}
```

## The HTTPValidationError object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}}}
```

## The NodeMetadataResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"NodeMetadataResponse":{"properties":{"node_path":{"title":"Node Path","type":"string"}},"required":["node_path"],"title":"NodeMetadataResponse","type":"object"}}}}
```

## The NodeResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"NodeResponse":{"properties":{"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"curtail_in_batch":{"nullable":true,"title":"Curtail In Batch","type":"boolean"},"curtailment_module_config":{"additionalProperties":true,"nullable":true,"title":"Curtailment Module Config","type":"object"},"id":{"format":"uuid","title":"Id","type":"string"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"platform_instance":{"nullable":true,"title":"Platform Instance","type":"string"},"polaris_node_name":{"title":"Polaris Node Name","type":"string"},"site_id":{"format":"uuid","title":"Site Id","type":"string"}},"required":["polaris_node_name","site_id","meta_data","curtailment_module_config","id","created_at"],"title":"NodeResponse","type":"object"}}}}
```

## The NotUpdatedDeviceCurtailmentResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"NotUpdatedDeviceCurtailmentResponse":{"properties":{"detail":{"title":"Detail","type":"string"},"reason":{"title":"Reason","type":"string"}},"required":["reason","detail"],"title":"NotUpdatedDeviceCurtailmentResponse","type":"object"}}}}
```

## The NotUpdatedDeviceLogSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"NotUpdatedDeviceLogSchema":{"properties":{"detail":{"title":"Detail","type":"string"},"reason":{"title":"Reason","type":"string"}},"required":["reason","detail"],"title":"NotUpdatedDeviceLogSchema","type":"object"}}}}
```

## The NullableDeliveryStatus object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"NullableDeliveryStatus":{"enum":["1","2","3","4","6","7","8","9","0","-1"],"title":"NullableDeliveryStatus","type":"string"}}}}
```

## The RestRelayRequest object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"RestRelayRequest":{"description":"Wrapper for OpenEMS API rest request forwarded to curtailment container","properties":{"body":{"additionalProperties":true,"nullable":true,"title":"Body","type":"object"},"headers":{"additionalProperties":{"type":"string"},"nullable":true,"title":"Headers","type":"object"},"method":{"enum":["GET","POST","PUT","PATCH","DELETE"],"title":"Method","type":"string"},"password":{"nullable":true,"title":"Password","type":"string"},"path":{"title":"Path","type":"string"},"query_params":{"additionalProperties":{"type":"string"},"nullable":true,"title":"Query Params","type":"object"},"username":{"nullable":true,"title":"Username","type":"string"}},"required":["method","path"],"title":"RestRelayRequest","type":"object"}}}}
```

## The RestRelayResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"RestRelayResponse":{"description":"Response returned by the edge ``rest_request`` direct method.","properties":{"body":{"title":"Body"},"headers":{"additionalProperties":true,"title":"Headers","type":"object"},"status_code":{"title":"Status Code","type":"integer"}},"required":["status_code","headers","body"],"title":"RestRelayResponse","type":"object"}}}}
```

## The ReturnLogSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"ReturnLogSchema":{"properties":{"category":{"title":"Category","type":"string"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"},"result":{"$ref":"#/components/schemas/CurtailmentLogResultSchema","nullable":true,"title":"Result"},"site_id":{"format":"uuid","title":"Site Id","type":"string"},"status":{"$ref":"#/components/schemas/CurtailmentOperationStatus"},"value":{"nullable":true,"title":"Value","type":"string"},"watchdog":{"title":"Watchdog","type":"boolean"}},"required":["site_id","value","status","category","result","watchdog","id","created_at"],"title":"ReturnLogSchema","type":"object"},"CurtailmentLogResultSchema":{"properties":{"not_updated_devices":{"additionalProperties":{"$ref":"#/components/schemas/NotUpdatedDeviceLogSchema"},"title":"Not Updated Devices","type":"object"},"updated_devices":{"additionalProperties":{"$ref":"#/components/schemas/UpdatedDeviceLogSchema"},"title":"Updated Devices","type":"object"}},"required":["updated_devices","not_updated_devices"],"title":"CurtailmentLogResultSchema","type":"object"},"NotUpdatedDeviceLogSchema":{"properties":{"detail":{"title":"Detail","type":"string"},"reason":{"title":"Reason","type":"string"}},"required":["reason","detail"],"title":"NotUpdatedDeviceLogSchema","type":"object"},"UpdatedDeviceLogSchema":{"properties":{"value":{"title":"Value","type":"number"}},"required":["value"],"title":"UpdatedDeviceLogSchema","type":"object"},"CurtailmentOperationStatus":{"enum":["completed","exception"],"title":"CurtailmentOperationStatus","type":"string"}}}}
```

## The SiteDetailsResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteDetailsResponse":{"properties":{"created_at":{"format":"date-time","title":"Created At","type":"string"},"curtailment_time_limit":{"exclusiveMinimum":true,"minimum":0,"nullable":true,"title":"Curtailment Time Limit","type":"integer"},"cyclic_write_timeout":{"minimum":0,"nullable":true,"title":"Cyclic Write Timeout","type":"integer"},"id":{"format":"uuid","title":"Id","type":"string"},"meta_data":{"additionalProperties":true,"default":{},"nullable":true,"title":"Meta Data","type":"object"},"metrics":{"items":{"anyOf":[{"$ref":"#/components/schemas/SiteMetric"},{"$ref":"#/components/schemas/SiteDeviceMetric"}]},"title":"Metrics","type":"array"},"metrics_v2":{"items":{"anyOf":[{"$ref":"#/components/schemas/SiteMetric"},{"$ref":"#/components/schemas/SiteDeviceMetric"}]},"nullable":true,"title":"Metrics V2","type":"array"},"name":{"title":"Name","type":"string"},"site_tag":{"title":"Site Tag","type":"string"}},"required":["id","created_at","site_tag","name","metrics"],"title":"SiteDetailsResponse","type":"object"},"SiteMetric":{"properties":{"key":{"title":"Key","type":"string"},"timestamp":{"format":"date-time","title":"Timestamp","type":"string"},"value":{"title":"Value"}},"required":["key","value","timestamp"],"title":"SiteMetric","type":"object"},"SiteDeviceMetric":{"properties":{"device":{"title":"Device","type":"string"},"key":{"title":"Key","type":"string"},"timestamp":{"format":"date-time","title":"Timestamp","type":"string"},"value":{"title":"Value"}},"required":["key","value","timestamp","device"],"title":"SiteDeviceMetric","type":"object"}}}}
```

## The SiteDeviceMetric object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteDeviceMetric":{"properties":{"device":{"title":"Device","type":"string"},"key":{"title":"Key","type":"string"},"timestamp":{"format":"date-time","title":"Timestamp","type":"string"},"value":{"title":"Value"}},"required":["key","value","timestamp","device"],"title":"SiteDeviceMetric","type":"object"}}}}
```

## The SiteMetric object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteMetric":{"properties":{"key":{"title":"Key","type":"string"},"timestamp":{"format":"date-time","title":"Timestamp","type":"string"},"value":{"title":"Value"}},"required":["key","value","timestamp"],"title":"SiteMetric","type":"object"}}}}
```

## The SiteResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteResponse":{"properties":{"created_at":{"format":"date-time","title":"Created At","type":"string"},"curtailment_time_limit":{"exclusiveMinimum":true,"minimum":0,"nullable":true,"title":"Curtailment Time Limit","type":"integer"},"cyclic_write_timeout":{"minimum":0,"nullable":true,"title":"Cyclic Write Timeout","type":"integer"},"id":{"format":"uuid","title":"Id","type":"string"},"meta_data":{"additionalProperties":true,"default":{},"nullable":true,"title":"Meta Data","type":"object"},"name":{"title":"Name","type":"string"},"site_tag":{"title":"Site Tag","type":"string"}},"required":["id","created_at","site_tag","name"],"title":"SiteResponse","type":"object"}}}}
```

## The SiteScheduleCreateSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteScheduleCreateSchema":{"properties":{"category":{"title":"Category","type":"string"},"schedule":{"additionalProperties":{"nullable":true,"type":"number"},"title":"Schedule","type":"object"},"site_id":{"format":"uuid","title":"Site Id","type":"string"},"valid_on":{"format":"date","title":"Valid On","type":"string"}},"required":["category","valid_on","schedule","site_id"],"title":"SiteScheduleCreateSchema","type":"object"}}}}
```

## The SiteScheduleDeleteSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteScheduleDeleteSchema":{"properties":{"schedule":{"additionalProperties":{"nullable":true,"type":"number"},"title":"Schedule","type":"object"},"synchronization_result":{"additionalProperties":{"type":"string"},"title":"Synchronization Result","type":"object"}},"required":["schedule","synchronization_result"],"title":"SiteScheduleDeleteSchema","type":"object"}}}}
```

## The SiteScheduleSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteScheduleSchema":{"properties":{"category":{"title":"Category","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"},"schedule":{"additionalProperties":{"nullable":true,"type":"number"},"title":"Schedule","type":"object"},"site_id":{"format":"uuid","title":"Site Id","type":"string"},"synchronization_result":{"additionalProperties":{"type":"string"},"nullable":true,"title":"Synchronization Result","type":"object"},"valid_on":{"format":"date","title":"Valid On","type":"string"}},"required":["category","valid_on","schedule","id","site_id","synchronization_result"],"title":"SiteScheduleSchema","type":"object"}}}}
```

## The SiteScheduleUpdateSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteScheduleUpdateSchema":{"properties":{"schedule":{"additionalProperties":{"nullable":true,"type":"number"},"title":"Schedule","type":"object"},"site_id":{"format":"uuid","title":"Site Id","type":"string"}},"required":["site_id","schedule"],"title":"SiteScheduleUpdateSchema","type":"object"}}}}
```

## The SiteUpdate object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"SiteUpdate":{"properties":{"curtailment_time_limit":{"exclusiveMinimum":true,"minimum":0,"nullable":true,"title":"Curtailment Time Limit","type":"integer"},"cyclic_write_timeout":{"exclusiveMinimum":true,"minimum":0,"nullable":true,"title":"Cyclic Write Timeout","type":"integer"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"name":{"nullable":true,"title":"Name","type":"string"},"site_tag":{"nullable":true,"title":"Site Tag","type":"string"}},"title":"SiteUpdate","type":"object"}}}}
```

## The UpdatedDeviceCurtailmentResponse object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"UpdatedDeviceCurtailmentResponse":{"properties":{"value":{"anyOf":[{"type":"integer"},{"type":"string"}],"title":"Value"}},"required":["value"],"title":"UpdatedDeviceCurtailmentResponse","type":"object"}}}}
```

## The UpdatedDeviceLogSchema object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"UpdatedDeviceLogSchema":{"properties":{"value":{"title":"Value","type":"number"}},"required":["value"],"title":"UpdatedDeviceLogSchema","type":"object"}}}}
```

## The ValidationError object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}}}
```

## The VersionInfo object

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"components":{"schemas":{"VersionInfo":{"properties":{"alembic_version":{"title":"Alembic Version","type":"string"},"git_version":{"title":"Git Version","type":"string"}},"required":["alembic_version","git_version"],"title":"VersionInfo","type":"object"}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://renewables.docs.helinplatform.com/api-reference/models.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
